// -*- Mode: C++; -*-

#include "kmysqladmin/profile.h"
#include <string>

#ifndef _settings_h
#define _settings_h

#include "settingsignals.h"
class QFont;

class CSettings:public Settingsignals
{
protected:
    eProfile LastInit;
    eProfile GlobalSettings;
    eProfile FontSettings;
    bool init_files();
public:
    CSettings();
    ~CSettings();
    void SaveLastLogin(const std::string user,const std::string host,
		       const std::string port,const std::string pass);
    bool RetrieveLastLogin(std::string&user,std::string&host,
			   std::string&port,std::string&pass);
    void set_fixed_font( const std::string name, const int size, const int weight, const bool italic);
    void set_fixed_font( const QFont&fnt);
    void set_nprop_font( const std::string name, const int size, const int weight, const bool italic);
    void set_nprop_font( const QFont&fnt);

    void get_fixed_font(std::string&name, int&size, int&weight, bool&italic);

    QFont get_fixed_font();
    QFont get_nonprop_font();

    int ThreadPolltime()const;
    void ThreadPolltime(int aTimeout);
    
    int StatusPolltime()const;
    void StatusPolltime(int aTimeout);
};

extern CSettings GlobalSettings;
#endif
